#!C:/Programs/Strawberry/win64/perl/bin/perl.exe -I"."

#################################
#         Maths trainer         #
#################################
# Three-by-three linear systems #
#################################

use strict; use warnings;

use CGI;
use CGI::Carp "fatalsToBrowser";

my $cgi = new CGI;
print "Content-Type: text/html\n\n";
print '<!DOCTYPE html>', "\n\n";
# -------------------------------------------------------------
# Set $app_dir to the full path of the directory,
# where the template file "equations2.template.html" is located
my $app_dir = "C:\\Programs\\Apache24\\htdocs";
# -------------------------------------------------------------
my $questions; my $question;
my $equation1 = ''; my $equation2 = ''; my $equation3 = ''; my $solution = ''; my $rootx = ''; my $rooty = ''; my $rootz = '';
my $usolution; my $urootx; my $urooty; my $urootz;
my $evaluation; my $correct; my $correctanswer; my $notunique;
# Get parameters from 'calling' webpage and determine next button-push action
my %params = $cgi->Vars;
my $action = lc($params{'action'});
$action = 'init' unless ($action);
if ($action eq 'init' or $action eq 'new' or $action eq 'start' or $action eq 'next' or $action eq 'check') {
  my $nextaction;
  if ($action eq 'init' or $action eq 'new') {
    if ($action eq 'init') {
      $questions = 10;
    }
    else {
      $questions = $params{'hquestions'};
    }
    $question = 0;
    $notunique = int($questions / 10) + 1;                                     # 10% "not unique solution" questions
    $nextaction = 'start';
  }
  else {
    $question = $params{'hquestion'};
    $notunique = $params{'hnotunique'};
    if ($action eq 'start' or $action eq 'next') {
      if ($action eq 'start') {
        $questions = $params{'questions'};
        $correct = 0;
      }
      else {
        $questions = $params{'hquestions'};
        $correct = $params{'hcorrect'};
      }
      $nextaction = 'check';
    }
    elsif ($action eq 'check') {
      $questions = $params{'hquestions'};
      $correct = $params{'hcorrect'};
      if ($question < $questions) {
        $nextaction = 'next';
      }
      else {
        $nextaction = 'new';
      }
    }
  }
  # XSS protection: Potential risk characters removal and variable check!
  $questions =~ s/[^0-9]*//g; $correct =~ s/[^0-9]*//g;
  $question =~ s/[^0-9]*//g; $notunique =~ s/[^0-9]*//g;
  unless ($questions) {
    $questions = 10;
  }
  # Generate equation or check user answer
  if ($action eq 'start' or $action eq 'next') {
    $question++;
    # Generate equation
    ($equation1, $equation2, $equation3, $solution, $rootx, $rooty, $rootz, $notunique) = generateSystem($notunique);
    $usolution = ''; $urootx = ''; $urooty = ''; $urootz = ''; $evaluation = '';
  }
  elsif ($action eq 'check') {
    # Check user answer
    $equation1 = $params{'hequation1'}; $equation1 =~ s/[^xyz0-9\.\+\-\= ]*//g;
    $equation2 = $params{'hequation2'}; $equation2 =~ s/[^xyz0-9\.\+\-\= ]*//g;
    $equation3 = $params{'hequation3'}; $equation3 =~ s/[^xyz0-9\.\+\-\= ]*//g;
    ($solution, $rootx, $rooty, $rootz) = split(/\//, $params{'hsolution'});
    unless ($solution eq 'unique' or $solution eq 'none' or $solution eq 'infinity') {
      $solution = '';
    }
    $rootx =~ s/[^0-9\.\-]*//g; $rooty =~ s/[^0-9\.\-]*//g; $rootz =~ s/[^0-9\.\-]*//g;
    $usolution = $params{'solution'};
    $urootx = $params{'rootx'}; $urooty = $params{'rooty'}; $urootz = $params{'rootz'};
    $urootx =~ s/\,/\./g; $urooty =~ s/\,/\./g; $urootz =~ s/\,/\./g;          # this allows using the comma as decimal separator
    unless ($usolution eq 'unique' or $usolution eq 'none' or $usolution eq 'infinity') {
      $usolution = '';
    }
    unless ($urootx =~ /^(\d+|\d+\.\d+|-\d+|-\d+\.\d+)$/) {                    # check if x solution is decimal number
      $urootx = '';
    }
    unless ($urooty =~ /^(\d+|\d+\.\d+|-\d+|-\d+\.\d+)$/) {                    # check if y solution is decimal number
      $urooty = '';
    }
    unless ($urootz =~ /^(\d+|\d+\.\d+|-\d+|-\d+\.\d+)$/) {                    # check if z solution is decimal number
      $urootz = '';
    }
    $correctanswer = 0;
    if ($usolution and $usolution eq $solution) {
      # Solution type (unique, none, infinity) = correct
      $correctanswer = 1;
      # Check if unique root is correct
      if ($usolution eq 'unique') {
        if ($urootx eq '' or $urooty eq '' or $urootz eq '') {
          $correctanswer = 0
        }
        elsif ($urootx != $rootx or $urooty != $rooty or $urootz != $rootz) {
          $correctanswer = 0;
        }
      }
    }
    # User answer evaluation
    if ($correctanswer) {
      # Correct answer
      $evaluation = 'This is correct!';
      $correct++;
    }
    else {
      # False answer
      $evaluation = 'False! Answer is: ' . ucfirst($solution);
      # Display correct answer in this case
      if ($solution eq 'unique') {
        $evaluation .= ' solution x = ' . $rootx . ', y = ' . $rooty . ', z = ' . $rootz . '.';
      }
      elsif ($solution eq 'none') {
        $evaluation =~ s/none//i;
        $evaluation .= ' No solution.';
      }
      else {
        $evaluation .= ' of solutions.'
      }
    }
  }
  # Read template HTML file
  my $template = "$app_dir\\equations3.template.html";
  open(my $input, "<", $template)
    or die "Can't open template file $template: $!";
  my @lines = <$input>;
  close($input);
  # Create the webpage
  foreach my $line (@lines) {
    chomp($line);
    if ($line) {
      if (substr($line, 0, 1) eq '#') {                                        # a '#' at beginning of line indicates that line contains a tag
        $line = substr($line, 1);
        if ($line =~ /#questions#/) {
          $line =~ s/#questions#/$questions/;
          if ($action eq 'init' or $action eq 'new') {
            $line =~ s/#readonly#//;
          }
          else {
            $line =~ s/#readonly#/readonly="readonly"/;                        # disable modification of test-questions number during test
          }
        }
        elsif ($line =~ /#systemcount#/) {
          if ($action eq 'init' or $action eq 'new') {
            $line =~ s/#systemcount#/Equation system/;
          }
          else {
            $line =~ s/#systemcount#/Equation system $question\/$questions/;   # display actual question number
          }
        }
        elsif ($line =~ /#equation1#/) {
          $line =~ s/#equation1#/$equation1/;
        }
        elsif ($line =~ /#equation2#/) {
          $line =~ s/#equation2#/$equation2/;
        }
        elsif ($line =~ /#equation3#/) {
          $line =~ s/#equation3#/$equation3/;
        }
        elsif ($line =~ /#checked1#/) {
          if ($usolution eq 'unique') {
            $line =~ s/#checked1#/checked="checked"/;                          # check 'unique solution' radiobutton
          }
          else {
            $line =~ s/#checked1#//;
          }
        }
        elsif ($line =~ /#rootx#/) {
          $line =~ s/#rootx#/$urootx/;                                         # display x root (or nothing)
        }
        elsif ($line =~ /#rooty#/) {
          $line =~ s/#rooty#/$urooty/;                                         # display y root (or nothing)
        }
        elsif ($line =~ /#rootz#/) {
          $line =~ s/#rootz#/$urootz/;                                         # display z root (or nothing)
        }
        elsif ($line =~ /#checkedno#/) {
          if ($usolution eq 'none') {
            $line =~ s/#checkedno#/checked="checked"/;                         # check 'no solution' radiobutton
          }
          else {
            $line =~ s/#checkedno#//;
          }
        }
        elsif ($line =~ /#checkedinf#/) {
          if ($usolution eq 'infinity') {
            $line =~ s/#checkedinf#/checked="checked"/;                        # check 'infinity of solutions' radiobutton
          }
          else {
            $line =~ s/#checkedinf#//;
          }
        }
        elsif ($line =~ /#eval#/) {
          if ($evaluation) {
            $line =~ s/#eval#/$evaluation/;
            if ($correctanswer) {
              $line =~ s/#class#/class="bold"/;                                # display evaluation in black bold, if correct answer
            }
            else {
              $line =~ s/#class#/class="red"/;                                 # display evaluation in red bold, if false answer
            }
          }
          else {
            $line =~ s/#eval#/&nbsp;/;                                         # no evaluation displayed (case if question is asked)
            $line =~ s/ #class#//;
          }
        }
        elsif ($line =~ /#button#/) {
          my $button = ucfirst($nextaction);
          $line =~ s/#button#/$button/;                                        # set button caption to next action
        }
        elsif ($line =~ /#table#/) {
          # Display test evaluation table (at end of test)
          if ($nextaction eq 'new' and $questions >= 5) {                      # evaluate only, if there were at least 5 questions
            my $false = $questions - $correct;
            my $success = 100 * ($correct / $questions); $success = int($success + 0.5);
            # Use spaces (&nbsp;) to right-align the count values
            my $tquestions = sprintf("%4u", $questions); $tquestions =~ s/ /&nbsp; /g;
            my $tcorrect = sprintf("%4u", $correct); $tcorrect =~ s/ /&nbsp; /g;
            $false = sprintf("%4u", $false); $false =~ s/ /&nbsp; /g;
            $success = sprintf("%3u", $success); $success =~ s/ /&nbsp; /g;
            # Create table HTML
            my $table = '<table border="1" style="padding:5px">';
            $table .= '<tr><th colspan="2" align="center" style="padding:5px">Evaluation</td></tr>';
            $table .= '<tr><td style="padding:5px">Questions</td><td style="padding:5px">' . $tquestions . '</td></tr>';
            $table .= '<tr><td style="padding:5px">Correct</td><td style="padding:5px">' . $tcorrect . '</td></tr>';
            $table .= '<tr><td style="padding:5px">False</td><td style="padding:5px">' . $false . '</td></tr>';
            $table .= '<tr><td style="padding:5px">Success</td><td style="padding:5px">' . $success . '%</td></tr>';
            $table .= '</table>';
            $line =~ s/#table#/$table/;
          }
          # Displaay nothing if test not yet done
          else {
            $line =~ s/#table#/&nbsp;/;
          }
        }
        elsif ($line =~ /#hquestions#/) {
          $line =~ s/#hquestions#/$questions/;                                 # save test-questions number to hidden field
        }
        elsif ($line =~ /#hquestion#/) {
          $line =~ s/#hquestion#/$question/;                                   # save actual question number to hidden field
        }
        elsif ($line =~ /#hequation1#/) {
          $line =~ s/#hequation1#/$equation1/;                                 # save equation 1 string to hidden field
        }
        elsif ($line =~ /#hequation2#/) {
          $line =~ s/#hequation2#/$equation2/;                                 # save equation 2 string to hidden field
        }
        elsif ($line =~ /#hequation3#/) {
          $line =~ s/#hequation3#/$equation3/;                                 # save equation 3 string to hidden field
        }
        elsif ($line =~ /#hsolution#/) {
          $line =~ s/#hsolution#/$solution\/$rootx\/$rooty\/$rootz/;           # save actual solution to hidden field
        }
        elsif ($line =~ /#hcorrect#/) {
          $line =~ s/#hcorrect#/$correct/;                                     # save number of correct answers to hidden field
        }
        elsif ($line =~ /#hnotunique#/) {
          $line =~ s/#hnotunique#/$notunique/;                                 # save number of "not unique solutions" questions
        }
      }
      # Print file-line (with tags replaced) to webpage
      unless ($line =~ /#/) {
        print "$line\n";
      }
    }
  }
}

# -------------------------------------
# Generate three-by-three linear system
# -------------------------------------

sub generateSystem {

  my ($equation1, $equation2, $equation3, $solution, $rootx, $rooty, $rootz); my ($notunique) = @_;
  my ($a1, $b1, $c1, $d1, $a2, $b2, $c2, $d2, $a3, $b3, $c3, $d3, $det, $detX, $detY, $detZ);
  # System of the 3 equations: ax + by + cz = d
  # Generate random values until they are 'ok'. In particular until result
  # is an integer or undefined. Eliminate systems with less than 3 variables,
  # where in any equation 2 coefficients are 'missing'. Limit number of "no
  # solution/infinity of solutions" exercises.
  do {
    # All coefficients between -10 and 10
    $a1 = int(rand(21)) - 10; $b1 = int(rand(21)) - 10; $c1 = int(rand(21)) - 10; $d1 = int(rand(21)) - 10;
    $a2 = int(rand(21)) - 10; $b2 = int(rand(21)) - 10; $c2 = int(rand(21)) - 10; $d2 = int(rand(21)) - 10;
    $a3 = int(rand(21)) - 10; $b3 = int(rand(21)) - 10; $c3 = int(rand(21)) - 10; $d3 = int(rand(21)) - 10;
    # Calculate determinants
    $det  = determinant3($a1, $b1, $c1, $a2, $b2, $c2, $a3, $b3, $c3);
    $detX = determinant3($d1, $b1, $c1, $d2, $b2, $c2, $d3, $b3, $c3);
    $detY = determinant3($a1, $d1, $c1, $a2, $d2, $c2, $a3, $d3, $c3);
    $detZ = determinant3($a1, $b1, $d1, $a2, $b2, $d2, $a3, $b3, $d3);
  }
  while (!(($det == 0 or ($detX % $det == 0 and $detY % $det == 0 and $detZ % $det == 0))
    and (($a1 != 0 and $b1 != 0) or ($a1 != 0 and $c1 != 0) or ($b1 != 0 and $c1 != 0))
    and (($a2 != 0 and $b2 != 0) or ($a2 != 0 and $c2 != 0) or ($b2 != 0 and $c2 != 0))
    and (($a3 != 0 and $b3 != 0) or ($a3 != 0 and $c3 != 0) or ($b3 != 0 and $c3 != 0))
    and ($a1 != 0 or $a2 != 0 or $a3 != 0)
    and ($b1 != 0 or $b2 != 0 or $b3 != 0)
    and ($c1 != 0 or $c2 != 0 or $c3 != 0)
    and ($det != 0 or ($det == 0 and $notunique > 0))));
  # Build equation strings
  $equation1 = formatEquation($a1, $b1, $c1, $d1);                             # pretty format the equations
  $equation2 = formatEquation($a2, $b2, $c2, $d2);
  $equation3 = formatEquation($a3, $b3, $c3, $d3);
  # Solution of the equation system using determinants and Cramer's rule
 if ($det == 0) {
    # No unique solution
    if ($detX != 0 or $detY != 0or $detZ != 0) {
      $solution = 'none';
    }
    else {
      $solution = 'infinity';
    }
    $notunique--;
  }
  else {
    # Unique solution for x, y and z
    $solution = 'unique';
    $rootx = $detX / $det;
    $rooty = $detY / $det;
    $rootz = $detZ / $det;
  }
  return($equation1, $equation2, $equation3, $solution, $rootx, $rooty, $rootz, $notunique);

}

# -------------------------
# Calculate 2x2 determinant
# -------------------------

sub determinant2 {

  my ($a, $b, $c, $d) = @_;
  return($a * $d - $b * $c);

}

# -------------------------
# Calculate 3x3 determinant
# -------------------------

sub determinant3 {

  my ($a, $b, $c, $d, $e, $f, $g, $h, $i) = @_;
  return($a * determinant2($e, $f, $h, $i) - $b * determinant2($d, $f, $g, $i) + $c * determinant2($d, $e, $g, $h));

}

# ---------------------------------------
# Format equation string (pretty display)
# ---------------------------------------

sub formatEquation {

  my ($x, $y, $z, $c) = @_; my $equation = '';

  # Format x coefficient and 'x'
  if ($x != 0) {                                                               # don't display if y coefficient = 0
    if ($x == 1) {                                                             # display 'x' instead of '1x'
      $equation = 'x';
    }
    elsif ($x == -1) {                                                         # display '-x' instead of '-1x'
      $equation = '-x';
    }
    else {
      $equation = $x . 'x';
    }
    if ($y > 0) {                                                              # pretty display for +/- operator
      $equation .= ' + ';
    }
    elsif ($y < 0) {
      $equation .= ' - ';
    }
  }
  # Format y coefficient and 'y'
  if ($y != 0) {                                                               # don't display if y coefficient = 0
    if ($x != 0) {                                                             # pretty display for y coefficient (x <> 0)
      if (abs($y) == 1) {
        $equation .= 'y';
      }
      else {
        $equation .= abs($y) . 'y';
      }
    }
    else {                                                                     # pretty display for y coefficient (x = 0)
      if ($y == 1) {
        $equation .= 'y';
      }
      elsif ($y == -1) {
        $equation .= '-y';
      }
      else {
        $equation .= $y . 'y';
      }
    }
  }
  if ($z > 0) {                                                                # pretty display for +/-
    $equation .= ' + ';
  }
  elsif ($z < 0) {
    $equation .= ' - ';
  }
  # Format z coefficient and 'z'
  if ($z != 0) {                                                               # don't display if z coefficient = 0
    if (abs($z) == 1) {                                                        # pretty display for z coefficient
      $equation .= 'z';
    }
    else {
      $equation .= abs($z) . 'z';
    }
  }
  # Display constant
  $equation .= ' = ' . $c;
  return($equation);

}
